/*
 * Copyright IBM Corp. and others 1991
 *
 * This program and the accompanying materials are made available under
 * the terms of the Eclipse Public License 2.0 which accompanies this
 * distribution and is available at https://www.eclipse.org/legal/epl-2.0/
 * or the Apache License, Version 2.0 which accompanies this distribution
 * and is available at https://www.apache.org/licenses/LICENSE-2.0.
 *
 * This Source Code may also be made available under the following
 * Secondary Licenses when the conditions for such availability set
 * forth in the Eclipse Public License, v. 2.0 are satisfied: GNU
 * General Public License, version 2 with the GNU Classpath
 * Exception [1] and GNU General Public License, version 2 with the
 * OpenJDK Assembly Exception [2].
 *
 * [1] https://www.gnu.org/software/classpath/license.html
 * [2] https://openjdk.org/legal/assembly-exception.html
 *
 * SPDX-License-Identifier: EPL-2.0 OR Apache-2.0 OR GPL-2.0-only WITH Classpath-exception-2.0 OR GPL-2.0-only WITH OpenJDK-assembly-exception-1.0
 */

/**
 * WARNING!!! GENERATED FILE
 *
 * This class is generated.
 * Do not use the Eclipse "Organize Imports" feature on this class.
 *
 * It can contain user content, but that content must be delimited with the
 * the tags
 * [BEGIN USER IMPORTS]
 * [END USER IMPORTS]
 *
 * or
 *
 * [BEGIN USER CODE]
 * [END USER CODE]
 *
 * These tags are entered as comments.  Characters before [ and after ] are ignored.
 * Lines between the tags are inserted into the newly generated file.
 *
 * IMPORTS are combined and inserted above newly generated imports.  CODE is combined
 * and inserted immediately after the class declaration
 *
 * All lines outside these tags are lost and replaced with newly generated code.
 */
package com.ibm.j9ddr.vm29.pointer.generated;

/*[BEGIN USER IMPORTS]*/
/*[END USER IMPORTS]*/

import com.ibm.j9ddr.CorruptDataException;
import com.ibm.j9ddr.vm29.pointer.*;
import com.ibm.j9ddr.vm29.structure.*;
import com.ibm.j9ddr.vm29.types.*;

/**
 * Structure: CPULoadEntryPointer
 *
 * A generated implementation of a VM structure
 *
 * This class contains generated code and MAY contain hand written user code.
 *
 * Hand written user code must be contained at the top of
 * the class file, specifically above
 * the comment line containing WARNING!!! GENERATED CODE
 *
 * ALL code below the GENERATED warning will be replaced with new generated code
 * each time the PointerGenerator utility is run.
 *
 * The generated code will provide getters for all elements in the CPULoadEntryPointer
 * structure.  Where possible, meaningful return types are inferred.
 *
 * The user may add methods to provide meaningful return types where only pointers
 * could be automatically inferred.
 */
@com.ibm.j9ddr.GeneratedPointerClass(structureClass=CPULoadEntry.class)
public class CPULoadEntryPointer extends StructurePointer {

	// NULL
	public static final CPULoadEntryPointer NULL = new CPULoadEntryPointer(0);

/*[BEGIN USER CODE]*/
/*[END USER CODE]*/

	// Do not call this constructor.  Use static method cast instead.
	protected CPULoadEntryPointer(long address) {
		super(address);
	}

	public static CPULoadEntryPointer cast(AbstractPointer structure) {
		return cast(structure.getAddress());
	}

	public static CPULoadEntryPointer cast(UDATA udata) {
		return cast(udata.longValue());
	}

	public static CPULoadEntryPointer cast(long address) {
		if (address == 0) {
			return NULL;
		}
		return new CPULoadEntryPointer(address);
	}

	public CPULoadEntryPointer add(long count) {
		return CPULoadEntryPointer.cast(address + (CPULoadEntry.SIZEOF * count));
	}

	public CPULoadEntryPointer add(Scalar count) {
		return add(count.longValue());
	}

	public CPULoadEntryPointer addOffset(long offset) {
		return CPULoadEntryPointer.cast(address + offset);
	}

	public CPULoadEntryPointer addOffset(Scalar offset) {
		return addOffset(offset.longValue());
	}

	public CPULoadEntryPointer sub(long count) {
		return CPULoadEntryPointer.cast(address - (CPULoadEntry.SIZEOF * count));
	}

	public CPULoadEntryPointer sub(Scalar count) {
		return sub(count.longValue());
	}

	public CPULoadEntryPointer subOffset(long offset) {
		return CPULoadEntryPointer.cast(address - offset);
	}

	public CPULoadEntryPointer subOffset(Scalar offset) {
		return subOffset(offset.longValue());
	}

	public CPULoadEntryPointer untag(long mask) {
		return CPULoadEntryPointer.cast(address & ~mask);
	}

	public CPULoadEntryPointer untag() {
		return untag(UDATA.SIZEOF - 1);
	}

	protected long sizeOfBaseType() {
		return CPULoadEntry.SIZEOF;
	}

	// Implementation methods

	// float jvmSystem
	@com.ibm.j9ddr.GeneratedFieldAccessor(offsetFieldName="_jvmSystemOffset_", declaredType="float")
	public float jvmSystem() throws CorruptDataException {
		return getFloatAtOffset(CPULoadEntry._jvmSystemOffset_);
	}

	// float jvmSystem
	public FloatPointer jvmSystemEA() throws CorruptDataException {
		return FloatPointer.cast(nonNullFieldEA(CPULoadEntry._jvmSystemOffset_));
	}

	// float jvmUser
	@com.ibm.j9ddr.GeneratedFieldAccessor(offsetFieldName="_jvmUserOffset_", declaredType="float")
	public float jvmUser() throws CorruptDataException {
		return getFloatAtOffset(CPULoadEntry._jvmUserOffset_);
	}

	// float jvmUser
	public FloatPointer jvmUserEA() throws CorruptDataException {
		return FloatPointer.cast(nonNullFieldEA(CPULoadEntry._jvmUserOffset_));
	}

	// float machineTotal
	@com.ibm.j9ddr.GeneratedFieldAccessor(offsetFieldName="_machineTotalOffset_", declaredType="float")
	public float machineTotal() throws CorruptDataException {
		return getFloatAtOffset(CPULoadEntry._machineTotalOffset_);
	}

	// float machineTotal
	public FloatPointer machineTotalEA() throws CorruptDataException {
		return FloatPointer.cast(nonNullFieldEA(CPULoadEntry._machineTotalOffset_));
	}

	// I64 ticks
	@com.ibm.j9ddr.GeneratedFieldAccessor(offsetFieldName="_ticksOffset_", declaredType="I64")
	public IDATA ticks() throws CorruptDataException {
		return new I64(getLongAtOffset(CPULoadEntry._ticksOffset_));
	}

	// I64 ticks
	public IDATAPointer ticksEA() throws CorruptDataException {
		return IDATAPointer.cast(nonNullFieldEA(CPULoadEntry._ticksOffset_));
	}

}
